import pitaru.sonia_v2_9.*; // added automatically when Sonia is imported from the processing menu.

ArrayList <Circle> circles;
ArrayList <Sample> samples;

int delta = 0;
float tempo = 4;

Circle active;

Linetime linea;
Crossa crossa1;
SnapButton snapButtonOr;
SnapButton snapButtonVe;
Slider slider;


int recTimeSec = 1; // number of seconds to record, determines the sample's max size.
boolean isRec = false;
boolean cht = false;
boolean snappy, snappx = false;

void setup() {
  size(screenWidth, screenHeight);
  smooth();

  linea = new Linetime(height/20, height/20*17, tempo);
  crossa1 = new Crossa(linea.minx+10, height/12*11, true);
  snapButtonOr = new SnapButton(crossa1.pos.x+390, height/12*11, true);
  snapButtonVe = new SnapButton(snapButtonOr.pos.x+50, height/12*11,false);
  slider = new Slider(crossa1.pos.x+40,height/12*11);

  samples = new ArrayList<Sample>();
  circles = new ArrayList<Circle>();

  Sonia.start(this); 
  LiveInput.start();  // start the liveInput engine (see liveInput example)
}

void draw() {
  background(235);

  if (snappy) quartiy();
  if (snappx) quartix();

  for (int i=0; i <  circles.size(); i++) {

    Circle c = circles.get(i);

    if ((linea.x < c.pos.x + c.rad) && (linea.x > c.pos.x - c.rad) && (linea.topLimit < c.pos.y + c.rad) && (linea.bottomLimit > c.pos.y - c.rad) && (isRec == false)) {
      samples.get(i).play();
      c.cdiam = c.diam * 1.5;
    }

    c.draw(mouseX, mouseY);
    float ratio = (float) (height-c.pos.y) / height;
    samples.get(i).setRate(ratio*88200);
    if (crossa1.isInside(c.pos.x, c.pos.y)) {
      circles.remove(i);
      samples.remove(i);
    }
  }

  snapButtonOr.display(mouseX,mouseY);
  snapButtonVe.display(mouseX,mouseY);
  crossa1.display();

  linea.display();
  linea.moove();
  
  slider.display(mouseX, mouseY);
  
   linea.tempo1 = map(slider.l,0,300,0,15);

  if (mousePressed) {
    if (cht) {
      crossa1.inflate();
    }
  }
}

void mousePressed() { 

  if (mouseButton == RIGHT) {
    for (int i=0; i <  circles.size(); i++) {
      if (circles.get(i).isInside(mouseX, mouseY)) {
        active = null;
        Circle c = new Circle(mouseX, mouseY);
        c.col = circles.get(i).col;
        c.col1 = circles.get(i).col1;        
        Sample sOrig = samples.get(i); 
        Sample sCopy = new Sample(sOrig.getNumFrames(), sOrig.getRate());
        float[] data = new float[sOrig.getNumFrames()];
        sOrig.read(data);
        sCopy.write(data);
        circles.add(c);
        samples.add(sCopy);
        //samples.set((samples.size()-1), samples.get(i));
        //samples.get(samples.size()-1) = samples.get(i);
        //dragLines.get(dragLines.size()-1).lenght = dragLines.get(i).lenght;
        break;
      }
    }
  }

  if ((circles.size() == 0) && (mouseY<linea.bottomLimit)) {
    samples.add(new Sample(44100*recTimeSec));
    circles.add(new Circle(mouseX, mouseY));

    LiveInput.startRec(samples.get(samples.size()-1)); // Record LiveInput data into the Sample object.
    // The recording will automatically end when all of the Sample's frames are filled with data.
    isRec = true;
  }

  for (int i=0; i <  circles.size(); i++) {
    if (circles.get(i).isInside(mouseX, mouseY)) {
      active = circles.get(i);
      circles.get(i).show = true;
      break;
    }
  }

  cht = false;
  for (int i=0; i <  circles.size(); i++) {
    if (circles.get(i).isInside(mouseX, mouseY)) 
      cht = true;
  }

  if ((cht == false)  && (mouseY<linea.bottomLimit)) {   
    samples.add(new Sample(44100*recTimeSec));
    circles.add(new Circle(mouseX, mouseY));
    LiveInput.startRec(samples.get(samples.size()-1)); // Record LiveInput data into the Sample object.
    // The recording will automatically end when all of the Sample's frames are filled with data.
    isRec = true;
  }

  if (crossa1.isInsideCross(mouseX, mouseY)) {
    circles.clear();
    samples.clear();
  }
  
  if (snapButtonVe.isInside(mouseX, mouseY)) {
    snappx = !snappx;
  }
  
    if (snapButtonOr.isInside(mouseX, mouseY)) {
    snappy = !snappy;
  }
  
}

void mouseReleased() { 
  active = null;
   
    if ((samples.size() > 0) && (isRec == true)) {
    LiveInput.stopRec(samples.get(samples.size()-1));
  }
  isRec = false;
  for (int i = 0; i< circles.size(); i++) 
    circles.get(i).show = false;
}

void mouseDragged() {
  if (active != null) {
    //active.pos.x = mouseX;
    //active.pos.y = mouseY;
    active.setPosition(mouseX, mouseY);
  }
      if(slider.isInside(mouseX,mouseY)) {
      slider.l = mouseX-slider.pos.x;
    }
}

void quartix() {
  stroke(200);
  strokeWeight(1);
  for (int i = 0; i<9; i++) {
    line(linea.minx+i*((linea.maxx-linea.minx)/8),linea.topLimit+10,linea.minx+i*((linea.maxx-linea.minx)/8),linea.bottomLimit-10);
  }
}

void quartiy() {
  stroke(200);
  strokeWeight(1);
  for (int i = 0; i<11; i++) {
    line(linea.minx,linea.topLimit+10+i*((linea.bottomLimit-10-linea.topLimit-10)/10),linea.maxx,linea.topLimit+10+i*((linea.bottomLimit-10-linea.topLimit-10)/10));
  }
}

public void stop() { 
  Sonia.stop(); 
  super.stop();
} 

